<?
/* 
 * EDOMI beta (Version 1.57) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
Wird nur von app1000_itemFunctions.php aufgerufen (per Ajax)
*/

//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Eigene Includes
require(MAIN_PATH."/www/admin/include/php/config.php");
require(MAIN_PATH."/www/admin/include/php/base.php");


sql_connect();

if (checkAdmin($sid)) {cmd($cmd);}

function cmd($cmd) {
	global $appId,$winId,$data,$dataArr,$phpdata,$phpdataArr,$sid;

	if ($cmd=='irtransLearn') {
?>
		document.getElementById("<?echo $winId;?>-irinfo").innerHTML='<b>Bitte eine Taste auf der Fernbedienung betätigen...</b><br><div class="pbAnim" style="width:300px; height:3px; background:#505050; margin:5px; -webkit-animation-duration:<?echo global_irTimeout;?>s;"></div>';
		ajax("irtransLearnStart","<?echo $appId;?>","<?echo $winId;?>","<?echo $data;?>","<?ajaxValue($phpdata);?>");
<?
	}

	if ($cmd=='irtransLearnStart') {

		if ($phpdataArr[8]==0) {
			if ($phpdataArr[6]==0 && $phpdataArr[7]==0) {$hexcode=irLearn(1);}  	//Normal
			if ($phpdataArr[6]==1 && $phpdataArr[7]==0) {$hexcode=irLearn(2);} 		//langer Code
			if ($phpdataArr[6]==0 && $phpdataArr[7]==1) {$hexcode=irLearn(3);}  	//Repeat-Code
			if ($phpdataArr[6]==1 && $phpdataArr[7]==1) {$hexcode=irLearn(4);} 		//Repeat-Code und lang
		} else {
			//RAW-Modus: IR-Codes werden als RAW-Codes gelernt (und das Lernen wird Binär abgewickelt)
			if ($phpdataArr[7]==0) {$hexcode=irLearn(11);}  						//Normal
			if ($phpdataArr[7]==1) {$hexcode=irLearn(12);} 							//Repeat-Code
		}

		if ($hexcode!==false) {
?>
			document.getElementById("<?echo $winId;?>-irinfo").innerHTML='<span style="background:#80e000; padding:5px;"><b>IR-Befehl wurde übernommen</b></span>';
			document.getElementById("<?echo $winId;?>-fd4").value='<?echo $hexcode;?>';
<?
		} else {
?>
			document.getElementById("<?echo $winId;?>-irinfo").innerHTML='<span style="color:#ffffff; background:#ff0000; padding:5px;"><b>Timeout oder Fehler</b></span>';
<?
		}
	}


	if ($cmd=='irtransSend' && !isEmpty(global_irIp)) {
		if (!isEmpty($phpdataArr[4])) {
			$ir='sndhex LB,H'.$phpdataArr[4];


			if ($ipSocket=socket_create(AF_INET,SOCK_DGRAM,SOL_UDP)) {
				socket_sendto($ipSocket,$ir,strlen($ir),0,global_irIp,global_irPort);
				socket_close($ipSocket);
/*
				//auf Antwort warten
				if ($socketUDP=socket_create(AF_INET,SOCK_DGRAM,SOL_UDP)) {
					if (socket_bind($socketUDP,0,global_irPort)) {
						socket_set_option($socketUDP,SOL_SOCKET,SO_RCVTIMEO,array("sec"=>1,"usec"=>0)); //max. 1 Sekunde warten
						socket_recv($socketUDP,$r,1000,0); //1000: egal, Hauptsache lang genug für die Antwort
					}
				}
*/
				usleep(50*1000);
?>
				document.getElementById("<?echo $winId;?>-irinfo").innerHTML='<span style="background:#80e000; padding:5px;"><b>IR-Befehl wurde gesendet</b></span>';
<?
			}
		}
	}


	if ($cmd=='irtransReset' && !isEmpty(global_irIp)) {
		$ir='reset';
		if ($ipSocket=socket_create(AF_INET,SOCK_DGRAM,SOL_UDP)) {
			socket_sendto($ipSocket,$ir,strlen($ir),0,global_irIp,global_irPort);
			socket_close($ipSocket);
?>
			document.getElementById("<?echo $winId;?>-irinfo").innerHTML='<b>IRtrans wird neu gestartet...</b><br><div class="pbAnim" style="width:300px; height:3px; background:#505050; margin:5px; -webkit-animation-duration:7s;"></div>';
			ajax("irtransReset2","<?echo $appId;?>","<?echo $winId;?>","<?echo $data;?>","<?ajaxValue($phpdata);?>");
<?
		}
	}
	if ($cmd=='irtransReset2') {
		sleep(7);
?>
		document.getElementById("<?echo $winId;?>-irinfo").innerHTML='<span style="background:#80e000; padding:5px;"><b>IRtrans wurde neugestartet</b></span>';
<?
	}

}

sql_disconnect();


//-----------------------------------------------------------------------------------------------------------------------------------------------


function irLearn($mode) {

	if (isEmpty(global_irIp)) {return false;}

	$irCode='';

	//Lernen starten

	//ASCII-Modus
	if ($mode==1) {$ir='learn M0,W'.global_irTimeout;}
	if ($mode==2) {$ir='learn M0,X1,W'.global_irTimeout;}
	if ($mode==3) {$ir='learn M1,W'.global_irTimeout;}
	if ($mode==4) {$ir='learn M1,X1,W'.global_irTimeout;}

	//RAW/Binär-Modus
	if ($mode==11) {$ir=hexToBytes('c80000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000007125210803000');} //RAW, normal
	if ($mode==12) {$ir=hexToBytes('c8000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000792d210803000');} //RAW, Repeat-Code

	if ($socketUDP=socket_create(AF_INET,SOCK_DGRAM,SOL_UDP)) {
		socket_sendto($socketUDP,$ir,strlen($ir),0,global_irIp,global_irPort);
		socket_close($socketUDP);
	}

	//auf Antwort warten
	if ($socketUDP=socket_create(AF_INET,SOCK_DGRAM,SOL_UDP)) {
		if (socket_bind($socketUDP,0,global_irPort)) {
			//Timeout
			socket_set_option($socketUDP,SOL_SOCKET,SO_RCVTIMEO,array("sec"=>global_irTimeout,"usec"=>0));
			//Warten auf Empfang
			$bytes=socket_recv($socketUDP,$r,1024,0); //1024: egal, Hauptsache lang genug für die Antwort
			if ($bytes!==false) {
				if ($mode<11) {
					//ASCII-Modus
					if (strpos($r,'LEARN ')!==false) {$irCode=str_replace('LEARN ','',$r);}
				} else {
					//RAW/Binär-Modus
					if (substr($r,0,1)==chr(242)) {$irCode=strtoupper(bytesToHex(substr($r,1,strlen($r)-1)));}
				}
			}
		}
	}

	//Lernen stoppen
	//### ist im ASCII-Modus eigentlich Quatsch. "Stoppt" nicht das Lernen, sondern fordert den Code an (im RAW-Modus).
	//### Wir sind aber im ASCII-Modus - daher eigentlich Blödsinn. ABER: Ohne dies hier, stürzt IRtrans nach dem Lernen ab, sobald etwas gesendet wird...
	$ir=hexToBytes('c8000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000500000000');
	if ($socketUDP=socket_create(AF_INET,SOCK_DGRAM,SOL_UDP)) {
		socket_sendto($socketUDP,$ir,strlen($ir),0,global_irIp,global_irPort);
		socket_close($socketUDP);
	}

	if ($irCode!='') {
		return $irCode;
	} else {
		return false;
	}
}

function hexToBytes($n) {
	return pack('H*',$n);
}

function bytesToHex($n) {
	//return: String mit 2-stelligen Hexzahlen ("0A0B0C...")
	$nn=unpack('H*',$n);
	$r=array_shift($nn);
	return $r;
}
?>
