<?
/* 
 * EDOMI beta (Version 1.57) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
======================================================================================================================================================
KO per HTTP-Request setzen (Filter: db.httpKo)
Aufruf: http://<IP>/remote/?login=[Remote-Login]&pass=[Remote-Passwort]&koid=[db.ko.id]&kovalue=[KO-Value]
======================================================================================================================================================
*/
//Globale Includes
require("../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Fehler-Level
error_reporting(0);

//Timeout
set_time_limit(30);


sql_connect();


$gaId=preg_replace("/[^0-9]/",'',httpGetVar('koid'));


header("Content-Type: text/plain");
if (checkRemoteLoginPass(httpGetVar('login'),httpGetVar('pass'))) {

	if (isset($_GET['kovalue'])) {
		$gaValue=httpGetVar('kovalue');

		//Wert setzen
		if (httpKoSet($gaId,$gaValue)) {
			echo 'OK;'.$gaId.';'.$gaValue.';';
		} else {
			echo 'ERROR;'.$gaId.';FORBIDDEN;';		//KO ist nicht in db.httpKo gelistet
		}

	} else {
	
		//Wert abfragen
		$n=httpKoGet($gaId);
		if ($n!==false) {
			echo $n;
		} else {
			echo 'ERROR;'.$gaId.';FORBIDDEN;';		//KO ist nicht in db.httpKo gelistet
		}

	}

} else {
	echo 'ERROR;LOGIN;';	 						//falsches Login/Pass
}

sql_disconnect();


function checkRemoteLoginPass($login,$pass) {
	//prüft, ob Remote-Logindaten korrekt sind und setzt actiondate
	//return: true=Ok, false=Logindaten sind fehlerhaft
	$ss1=sql_call("SELECT id FROM edomiAdmin.user WHERE (typ=10 AND login='".sql_encodeValue($login)."' AND pass='".sql_encodeValue($pass)."')");
	if ($n=sql_result($ss1)) {
		sql_call("UPDATE edomiAdmin.user SET actiondate=".sql_getNow().",loginip='".$_SERVER['REMOTE_ADDR']."' WHERE id=".$n['id']);
		return true;
	}
	return false;
}

function httpKoSet($gaId,$gaValue) {
	$ss1=sql_call("SELECT id FROM edomiLive.httpKo WHERE (gaid=".$gaId.")");
	if ($n=sql_result($ss1)) {
		sql_call("INSERT INTO edomiLive.RAMknxRead (mode,gatyp,gaid,value) VALUES (4,0,".$gaId.",'".sql_encodeValue($gaValue)."')");
		return true;
	}
	return false;
}

function httpKoGet($gaId) {
	$ss1=sql_call("SELECT id FROM edomiLive.httpKo WHERE (gaid=".$gaId.")");
	if ($n=sql_result($ss1)) {
		$ss2=sql_call("SELECT value FROM edomiLive.RAMko WHERE (id=".$gaId.")");
		if ($nn=sql_result($ss2)) {
			return $nn['value'];
		}
	}
	return false;
}

?>
