<?
/* 
 * EDOMI beta (Version 1.57) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
======================================================================================================================================================
ADMIN/VISU/MAIN: Kamera-Zugriff
======================================================================================================================================================
*/

function getPreviewLiveCamImg($camUrl,$camMjpeg,$camMask) {
	//Preview für Adminseite (Kameraeinstellungen)
	//$camUrl: URL
	//$camMjpeg: 0=JPG, 1=MJPEG
	//$camMask: String mit den Maskendaten
	//return: false, oder Bild-Dateiname (ohne Pfad)

	if ($camUrl!='') {
		//Bild grabben
		if ($camMjpeg==0) {$img=getLiveCamImgFromSnapshot($camUrl);} else {$img=getLiveCamImgFromStream($camUrl);}
		if ($img) {
			//Speichern (temporär) und Dateiname zurückgeben
			deleteFiles(MAIN_PATH.'/www/data/tmp/campreview.jpg');
			$r=saveCamImg(0,0,$img,MAIN_PATH.'/www/data/tmp/campreview.jpg',$camMask);
			if ($r!==false && file_exists(MAIN_PATH.'/www/data/tmp/campreview.jpg')) {return 'campreview.jpg';}
		}
	}
	return false;
}

function getServerLiveCamImg($camId) {
	//Liefert immer(!) ein echtes Livebild (greift also NICHT auf den Cache zurück)
	//$camId: db.cam.id
	//return: false, oder Bilddaten(!)

	if ($camId>0) {
		$ss1=sql_call("SELECT id,url,mjpeg FROM edomiLive.cam WHERE (id=".$camId.")");
		if ($n=sql_result($ss1)) {
			//Timestamp in DB aktualisiern (VOR dem eigentlichen Grabben, damit bei mehreren Instanzen möglichst nicht mehrmals gegrabbt wird)
			sql_call("UPDATE edomiLive.cam SET datetime=".sql_getNow()." WHERE id=".$camId);
			//Bild grabben
			if ($n['mjpeg']==0) {$img=getLiveCamImgFromSnapshot($n['url']);} else {$img=getLiveCamImgFromStream($n['url']);}
			if ($img) {
				//Bild speichern und Bilddaten zurückgeben
				//(als tmp-Datei speichern und wenn das Speichern abgeschlossen ist umbenennen - dient quasi als write-lock bei mehreren Clients)
				$r=saveCamImg(2,$camId,$img,MAIN_PATH.'/www/data/liveproject/cam/live/tmp'.$camId.'.jpg',false);
				if ($r!==false && file_exists(MAIN_PATH.'/www/data/liveproject/cam/live/tmp'.$camId.'.jpg')) {rename(MAIN_PATH.'/www/data/liveproject/cam/live/tmp'.$camId.'.jpg',MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg');}
				if ($r==0) {return $img;}
				if ($r==1) {return file_get_contents(MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg');}
			}
		}
		sql_close($ss1);
	}
	return false;
}

function getVisuLiveCamImg($camId) {
	//Liefert entweder ein echtes Livebild oder ein Bild aus dem Cache (je nach Einstellung: global_camLiveMaxRefresh)
	//$camId: db.cam.id
	//return: false, oder Bild-Dateiname (ohne Pfad)

	if ($camId>0) {
		$ss1=sql_call("SELECT *,(DATE_ADD(datetime,INTERVAL ".global_camLiveMaxRefresh." SECOND)<=".sql_getNow().") AS ok FROM edomiLive.cam WHERE (id=".$camId.")");
		if ($n=sql_result($ss1)) {
			if ($n['ok']) {
				//Timestamp in DB aktualisiern (VOR dem eigentlichen Grabben, damit bei mehreren Instanzen möglichst nicht mehrmals gegrabbt wird)
				sql_call("UPDATE edomiLive.cam SET datetime=".sql_getNow()." WHERE id=".$camId);
				//Bild grabben
				if ($n['mjpeg']==0) {$img=getLiveCamImgFromSnapshot($n['url']);} else {$img=getLiveCamImgFromStream($n['url']);}
				if ($img) {
					//Bild speichern und Bild-URL zurückgeben
					//(als tmp-Datei speichern und wenn das Speichern abgeschlossen ist umbenennen - dient quasi als write-lock bei mehreren Clients)
					$r=saveCamImg(1,$camId,$img,MAIN_PATH.'/www/data/liveproject/cam/live/tmp'.$camId.'.jpg',false);
					if ($r!==false && file_exists(MAIN_PATH.'/www/data/liveproject/cam/live/tmp'.$camId.'.jpg')) {rename(MAIN_PATH.'/www/data/liveproject/cam/live/tmp'.$camId.'.jpg',MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg');}
					if (file_exists(MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg')) {return 'cam'.$camId.'.jpg';}
				}
			} else {
				//altes Bild aus Datei holen
				if (file_exists(MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg')) {return 'cam'.$camId.'.jpg';}
			}
		}
		sql_close($ss1);
	}
	return false;
}

function saveCamImg($mode,$camId,$img,$fn,$maskData) {
	//Maskiert ggf. das Kamera-Bild $img und speichert es unter $fn
	//$mode: 0=Preview, 1=Live, 2=Archiv
	//$camId: >0=db.cam.id (für die Maskendaten), 0=Preview (Maskendaten sind ggf. in $maskData)
	//$img: Bilddaten
	//$fn: Dateiname mit Pfad!
	//$maskData: false=Maskendaten aus DB holen, "..."=diese Maskendaten nehmen (für Preview), leer/null=keine Maskierung vornehmen
	//return: false=Fehler, 1=Bild wurde maskiert, 0=Bild wurde nicht maskiert

	if ($maskData===false) {
		$ss1=sql_call("SELECT mask FROM edomiLive.cam WHERE (id=".$camId.")");
		if ($n=sql_result($ss1)) {
			$maskData=$n['mask'];
		}
		sql_close($ss1);
	}
	
	$maskData=explode(',',$maskData);

	if (count($maskData)==6 && $maskData[0]>0 && $maskData[1]>0 && $maskData[2]>0 && (($mode==1 && $maskData[0]&1) || ($mode==2 && $maskData[0]&2) || ($mode==0)) && strpos($maskData[5],'1')!==false) {

		$img1=imagecreatefromstring($img);
		$anzX=$maskData[1];									//Auflösung (Blockanzahl)
		$anzY=$maskData[2];
		$colR=hexdec(substr(substr($maskData[3],-6),0,2));	//Blockfarbe	
		$colG=hexdec(substr(substr($maskData[3],-6),2,2));
		$colB=hexdec(substr(substr($maskData[3],-6),4,2));
		$w=imagesx($img1)/$anzX;							//Blockbreite/-höhe
		$h=imagesy($img1)/$anzY;

		if (substr($maskData[3],0,1)=='!') {
			//Ausschnitt vergrößern und ggf. maskieren:

			//Boundingbox finden
			$x1=999999999;
			$y1=999999999;
			$x2=-1;
			$y2=-1;
			for ($y=0;$y<$anzY;$y++) {
				for ($x=0;$x<$anzX;$x++) {
					if (substr($maskData[5],$x+($y*$anzX),1)==='1') {
						if ($x<$x1) {$x1=$x;}
						if ($y<$y1) {$y1=$y;}
						if ($x>$x2) {$x2=$x;}
						if ($y>$y2) {$y2=$y;}
					}
				}
			}
			$imgNewWidth=($x2-$x1)+1;
			$imgNewHeight=($y2-$y1)+1;

			//Maskieren (nur innerhalb der Boundingbox):
			for ($y=$y1;$y<=$y2;$y++) {
				for ($x=$x1;$x<=$x2;$x++) {
					if (substr($maskData[5],$x+($y*$anzX),1)==='0') {
						imagefilledrectangle($img1,$x*$w,$y*$h,$x*$w+$w,$y*$h+$h,imagecolorallocate($img1,$colR,$colG,$colB));
					}
				}
			}

			//Boundingbox ausschneiden und auf volle Bildgröße skalieren
			if ($imgNewWidth>0 && $imgNewHeight>0) {
				$img2=imagecreatetruecolor($imgNewWidth*$w,$imgNewHeight*$h);
				imagecopyresized($img2,$img1,0,0,$x1*$w,$y1*$h,$imgNewWidth*$w,$imgNewHeight*$h,$imgNewWidth*$w,$imgNewHeight*$h);
						
				//Neues Bild speichern
				imagejpeg($img2,$fn,$maskData[4]); 		//in Datei speichern
				ImageDestroy($img1); 					//Speicher freigeben!
				ImageDestroy($img2);
				return 1;
			}			
		} else {
			//Maskieren:
			for ($y=0;$y<$anzY;$y++) {
				for ($x=0;$x<$anzX;$x++) {
					if (substr($maskData[5],$x+($y*$anzX),1)==='1') {
						imagefilledrectangle($img1,$x*$w,$y*$h,$x*$w+$w,$y*$h+$h,imagecolorallocate($img1,$colR,$colG,$colB));
					}
				}
			}
			//Neues Bild speichern
			imagejpeg($img1,$fn,$maskData[4]); 		//in Datei speichern
			ImageDestroy($img1); 					//Speicher freigeben!
			return 1;
		}
	} else {
		//Keine Maskierung vorhanden/aktiviert:
		$f=fopen($fn,'w');
		fwrite($f,$img);
		fclose($f);
		return 0;
	}

	return false;
}

function getLiveCamImgFromSnapshot($url) {
	//$url: URL des Snapshots (JPG):
	//	- reine URL, z.B. http://login:pass@1.2.3.4/...
	//	- oder mittels cUrl, z.B. CURL***ANY|BASIC|DIGEST***login***pass***http://1.2.3.4/snapshot.jpg
	//return: die reinen JPG-Daten, oder false

	$tmp=explode('***',$url,5);
	if (strtoupper(trim($tmp[0]))=='CURL') {

		if (strtoupper(trim($tmp[1]))=='ANY') 			{$auth=CURLAUTH_ANY;}
		else if (strtoupper(trim($tmp[1]))=='BASIC') 	{$auth=CURLAUTH_BASIC;}
		else if (strtoupper(trim($tmp[1]))=='DIGEST') 	{$auth=CURLAUTH_DIGEST;}

		$curl=curl_init();
		curl_setopt($curl,CURLOPT_URL,trim($tmp[4]));
		curl_setopt($curl,CURLOPT_RETURNTRANSFER,true);
		curl_setopt($curl,CURLOPT_USERPWD,trim($tmp[2]).':'.trim($tmp[3]));		
		curl_setopt($curl,CURLOPT_HTTPAUTH,$auth);
		$r=curl_exec($curl);
		curl_close($curl);
		return $r;

	} else {
		$ctx=stream_context_create(array('http' => array('timeout' => 5 )));	//5 Sekunden Timeout
		return file_get_contents($url,0,$ctx,0,10*1024*1024);					//max. 10 MB, dann Abbruch (falls man versehentlich einen MJPEG-Stream ausgewählt hat bei Preview)
	}
}

function getLiveCamImgFromStream($url) {
	//$url: URL des MJPEG-Streams (HTTP)
	//return: die reinen JPG-Daten, oder false

	$timeout=10; 			//nach 10 Sekunden abbrechen (Verbindungsaufbau NICHT mit eingerechnet)

	$jpgStartString=chr(0xff).chr(0xd8);
	$img=false;
	$frameStartString=false;

	//Zeichenkette im Header finden, die die einzelnen JPG-Frames begrenzt
	$n=get_headers($url);
	if ($n!==false) {
		$t=count($n)-1;
		while ($t>=0 && $frameStartString===false) {	//Rückwärts suchen, da Boundary meistens am Ende zu finden ist...
			$tmp1=explode(':',trim($n[$t]));
			if (strToUpper(trim($tmp1[0]))=='CONTENT-TYPE') {
				$tmp2=explode(';',$tmp1[1]);
				for ($tt=0;$tt<count($tmp2);$tt++) {
					if (strToUpper(substr(trim($tmp2[$tt]),0,9))=='BOUNDARY=') {
						$frameStartString=substr(trim($tmp2[$tt]),9);
						break;
					}
				}		
			}
			$t--;
		}
	}

	//MJPEG-Stream anzapfen und das erste vollständige JPG extrahieren
	if ($frameStartString!==false) {
		$data='';

		$ctx=stream_context_create(array('http'=>array('timeout' => 3)));
		$f=fopen($url,'r',false,$ctx);
		if ($f) {

			$t1=microtime(true);
			
			//erstes Boundary abwarten
			do {
				$n=fgets($f);
			} while (strpos($n,$frameStartString)===false && ((microtime(true)-$t1)<$timeout));


			//bis zum nächsten Boundary mitlesen
			if (strpos($n,$frameStartString)!==false) { //Timeout?
				do {
					$n=fgets($f);
					if (strpos($n,$frameStartString)===false) {
						$data.=$n;
					}
				} while (strpos($n,$frameStartString)===false && ((microtime(true)-$t1)<$timeout));
		
				//Start-Bytes suchen und alles davor entfernen
				if (strpos($n,$frameStartString)!==false) { //Timeout?
					$x=strpos($data,$jpgStartString);
					if ($x!==false) {
						$img=substr($data,$x);
					}
				}
			}
			
		}
		fclose($f);
	}

	return $img;
}

?>
