/* 
 * EDOMI beta (Version 1.57) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 23 (Anwesenheitssimulation)
//----------------------------

function control23_constructControl(obj,item) {

	var mheight=(obj.dataset.var10!='')?obj.dataset.var10:40;

	var n="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		n+="<tr style='height:"+mheight+"px;'><td align='center' id='e-"+item.id+"-info'><div id='e-"+item.id+"-infotext' style='max-height:"+mheight+"px; overflow:hidden;'>"+item.title+"</div></td></tr>";
		n+="<tr><td align='center' style='border-top:1px solid;"+((obj.dataset.var3==1)?"border-bottom:1px solid;":"")+"'><div id='e-"+item.id+"-edit' style='width:100%; height:100%; overflow:hidden;'></div></td></tr>";

	if (obj.dataset.var3==1) {
		n+="<tr style='height:"+mheight+"px;'><td>";
			n+="<table cellpadding='0' cellspacing='0' width='100%' height='100%' border='0'>";
				n+="<tr align='center'>";
					n+="<td id='e-"+item.id+"-off'><div id='e-"+item.id+"-status0' style='max-height:"+mheight+"px; overflow:hidden; display:inline-block; border:1px solid transparent; border-radius:3px; padding:1px;'>aus</div></td>";
					n+="<td id='e-"+item.id+"-rec'><div id='e-"+item.id+"-status2' style='max-height:"+mheight+"px; overflow:hidden; display:inline-block; border:1px solid transparent; border-radius:3px; padding:1px;'>&nbsp;&nbsp;+&nbsp;&nbsp;</div></td>";
					n+="<td id='e-"+item.id+"-play'><div id='e-"+item.id+"-status1' style='max-height:"+mheight+"px; overflow:hidden; display:inline-block; border:1px solid transparent; border-radius:3px; padding:1px;'>ein</div></td>";
				n+="</tr>";
			n+="</table>";
		n+="</td></tr>";
	}
	n+="</table>";
	obj.innerHTML=n;
	
	control23_ShowInfo(item.id);

	if (obj.dataset.var0==1) {document.getElementById("e-"+item.id+"-edit").addEventListener(downEvent,function(){if (!checkClick()){return;} visuElementClick(item.id);},false);}

	document.getElementById("e-"+item.id+"-info").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control23_ShowInfo(item.id);},false);
	if (obj.dataset.var3==1) {
		document.getElementById("e-"+item.id+"-off").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); setKoValue(item.gaid,0);},false);
		document.getElementById("e-"+item.id+"-rec").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); setKoValue(item.gaid,2);},false);
		document.getElementById("e-"+item.id+"-play").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); setKoValue(item.gaid,1);},false);
	}
}

function control23_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	control23_Switch(obj.dataset.id,kovalue);
	control23_ShowInfo(obj.dataset.id);
}

function control23_ShowInfo(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		d.dataset.cursor="";
		var n=elementId+AJAX_SEPARATOR1+"0"+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1;
		ajax("awsInfo",1023,visu_visuid,0,n,"");
	}
}

function control23_Switch(elementId,mode) {
	var s0=document.getElementById("e-"+elementId+"-status0");
	var s1=document.getElementById("e-"+elementId+"-status1");
	var s2=document.getElementById("e-"+elementId+"-status2");
	if (s0 && s1 && s2) {
		if (mode==2) {
			s0.style.border="1px solid transparent";
			s1.style.border="1px solid transparent";
			s2.style.border="1px solid";
		} else if (mode==1) {
			s0.style.border="1px solid transparent";
			s1.style.border="1px solid";
			s2.style.border="1px solid transparent";
		} else {
			s0.style.border="1px solid";
			s1.style.border="1px solid transparent";
			s2.style.border="1px solid transparent";
		}
	}
}

//PHP-Callbacks
//----------------------------

function control23_callbackList(elementId,content) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		document.getElementById("e-"+elementId+"-edit").innerHTML=content;
	}
}
