/* 
 * EDOMI beta (Version 1.57) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 27 (Rundinstrument)
//----------------------------

function control27_constructControl(obj,item) {
	var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		n+="<canvas id='e-"+item.id+"-canvas' style='position:absolute; box-sizing:border-box;'></canvas>";
		n+="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
			n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
		n+="</table>";
	n+="</div>";
	obj.innerHTML=n;

	if (obj.dataset.var0==1) {obj.addEventListener(downEvent,function(){if (!checkClick()){return;} visuElementClick(item.id);},false);}
}

function control27_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	document.getElementById("e-"+obj.dataset.id+"-text").innerHTML=pS(obj.dataset.d_text,kovalue);
	control27_Draw(obj.dataset.id,kovalue);
}

function control27_Draw(elementId,koValue) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var canvas=document.getElementById("e-"+elementId+"-canvas");
		var canvassize=element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-canvas"));
		var c=canvasScale(canvas,canvassize.w,canvassize.h);

		if (c!==false) {
			c.clearRect(0,0,canvassize.w,canvassize.h);

			var r=(canvassize.w/2);
			var mx=(canvassize.w/2);
			var my=(canvassize.h/2);

			var vmin=parseFloat(d.dataset.var3);
			var vmax=parseFloat(d.dataset.var4);
			var range=Math.abs(vmax-vmin);

			koValue=parseFloat(koValue);
			if (koValue<vmin) {koValue=vmin;}
			if (koValue>vmax) {koValue=vmax;}

			var a1=parseFloat(d.dataset.var9);
			var a2=parseFloat(d.dataset.var10);
			if (a2<a1) {a2+=360;}
			var arange=Math.abs(a2-a1);
			if (d.dataset.var5>(canvassize.w/2)) {d.dataset.var5=0;}	//arc() wirft sonst einen Fehler!

			var avalue=(arange/range)*(koValue-vmin)+a1;				
			var x=Math.sin((-avalue)*Math.PI/180);
			var y=Math.cos((-avalue)*Math.PI/180);

			if (d.dataset.var5>0) {var scalaLen=d.dataset.var5;} else {var scalaLen=r/15;}

			c.strokeStyle=d.style.color;
			c.fillStyle=d.style.color;


			if (d.dataset.var1==1 || d.dataset.var1==2) {
				//----------------------
				//Zeiger
				//----------------------
				drawScala();
				
				c.globalAlpha=1;
				if (d.dataset.var2>0) {c.lineWidth=d.dataset.var2;} else {c.lineWidth=r/30;}
				c.lineCap="round";
				c.beginPath();
					c.moveTo(mx,my);
					c.lineTo(x*(r-(c.lineWidth/2))+mx,y*(r-(c.lineWidth/2))+my);
				c.stroke();

				//Mittelpunkt
				if (d.dataset.var1==2) {
					c.beginPath();
						c.arc(mx,my,c.lineWidth,0,2*Math.PI,false);
					c.fill();
				}

			} else if (d.dataset.var1==3) {
				//----------------------
				//Strich
				//----------------------
				drawScala();

				c.globalAlpha=1;
				if (d.dataset.var2>0) {c.lineWidth=d.dataset.var2;} else {c.lineWidth=r/30;}
				c.lineCap="round";
				c.beginPath();
					c.moveTo(x*(r-(c.lineWidth/2))+mx,y*(r-(c.lineWidth/2))+my);
					c.lineTo(x*(r-scalaLen+(c.lineWidth/2))+mx,y*(r-scalaLen+(c.lineWidth/2))+my);
				c.stroke();

			} else if (d.dataset.var1==4) {
				//----------------------
				//Kreis
				//----------------------
				drawScala();

				c.globalAlpha=1;
				if (d.dataset.var2>0) {var len=d.dataset.var2;} else {var len=scalaLen/2;}
				c.lineWidth=1;
				c.beginPath();
					c.arc(x*(r-len)+mx,y*(r-len)+my,len,0,2*Math.PI,false);
				c.fill();

			} else if (d.dataset.var1==5) {
				//----------------------
				//Segment
				//----------------------
				drawScala();

				c.globalAlpha=1;
				c.lineWidth=1;
				c.lineCap="butt";
				c.beginPath();
					c.moveTo(mx,my);
					c.arc(mx,my,r,(a1+90)*Math.PI/180,(avalue+90)*Math.PI/180,false);
				c.fill();
				
			} else if (d.dataset.var1==6 || d.dataset.var1==7) {
				//----------------------
				//Kontur
				//----------------------
				drawScala();

				c.globalAlpha=1;
				if (d.dataset.var2>0) {c.lineWidth=d.dataset.var2;} else {c.lineWidth=scalaLen;}
				if (d.dataset.var1==6) {c.lineCap="butt";} else {c.lineCap="round";}
				c.beginPath();
					c.arc(mx,my,r-(c.lineWidth/2),(a1+90)*Math.PI/180,(avalue+90)*Math.PI/180,false);
				c.stroke();
				
			}
		}
	}
	
	function drawScala() {
		//Bereichsanzeige
		if (d.dataset.var8>0) {
			c.globalAlpha=(d.dataset.var8/100);
			if (d.dataset.var6==0) {
				c.lineCap="butt";
				c.lineWidth=scalaLen;
				c.beginPath();
					c.arc(mx,my,r-(scalaLen/2),(a1+90)*Math.PI/180,(a2+90)*Math.PI/180,false);
				c.stroke();
			} else if (d.dataset.var6==1) {
				c.lineCap="round";
				c.lineWidth=scalaLen;
				c.beginPath();
					c.arc(mx,my,r-(scalaLen/2),(a1+90)*Math.PI/180,(a2+90)*Math.PI/180,false);
				c.stroke();
			} else if (d.dataset.var6==2) {
				c.lineCap="butt";
				c.lineWidth=1;
				c.beginPath();
					c.moveTo(mx,my);
					c.arc(mx,my,r,(a1+90)*Math.PI/180,(a2+90)*Math.PI/180,false);
				c.fill();
			}
		}
		
		//Skala
		if (d.dataset.var7>0) {
			var step1=15;	//Nebenintervall (Grad!)
			var step2=30;	//Hauptintervall (Grad!)

			c.lineWidth=1;			
			c.lineCap="butt";
			
			var tmp1=parseInt(a1/step1)*step1;
			if (tmp1<a1) {tmp1+=step1;}
			if (tmp1==a1) {tmp1+=step1;}
			var tmp2=parseInt(a2/step1)*step1;
			if (tmp2>a2) {tmp2-=step1;}
			if (tmp2==a2) {tmp2-=step1;}

			c.globalAlpha=(d.dataset.var7/200);
			drawScalaLine(a1,scalaLen,step1,step2);
			drawScalaLine(a2,scalaLen,step1,step2);
			
			c.globalAlpha=(d.dataset.var7/100);
			for (var t=tmp1;t<=tmp2;t+=step1) {
				drawScalaLine(t,false,step1,step2);
			}
		}
	}

	function drawScalaLine(a,len,step1,step2) {
		if (len===false) {
			if (a % step2==0) {len=scalaLen;} else {len=scalaLen/2;}
		}
		var x=Math.sin((-a)*Math.PI/180);
		var y=Math.cos((-a)*Math.PI/180);
		c.beginPath();
			c.moveTo(x*r+mx,y*r+my);
			c.lineTo(x*(r-len)+mx,y*(r-len)+my);
		c.stroke();
	}
}
