<?
/* 
 * EDOMI beta (Version 1.57) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
======================================================================================================================================================
VISU: Grundfunktionen
======================================================================================================================================================
*/

/*
------------------------------------------------------------------------------------------------------------------------------------------------------
Login- und SID-Handling
------------------------------------------------------------------------------------------------------------------------------------------------------
*/

function loginVisu($visuId,$login,$pass) {
	//Visu (visuId) mit $login und $pass einloggen (erstellt eine neue SID)
	//return: die neue SID, false=ungültiges Login
	if ($userListId=checkVisuLoginPass($visuId,$login,$pass)) {
		//SID generieren und in DB speichern
		$sid=createVisuSid();
		sql_call("UPDATE edomiLive.visuUserList SET sid='".$sid."',logindate=".sql_getNow().",loginip='".$_SERVER['REMOTE_ADDR']."' WHERE (id=".$userListId.")");
		//JS die neue SID mitteilen
		return $sid;
	}
	return false;
}

function checkVisuLoginPass($visuId,$login,$pass) {
	//prüft, ob Visu-Logindaten korrekt sind 
	//return: 1..oo=db.visuUserList.id, false=Logindaten sind fehlerhaft
	$ss1=sql_call("SELECT a.id FROM edomiLive.visuUserList AS a,edomiLive.visuUser AS b WHERE (a.visuid=".sql_encodeValue($visuId)." AND a.targetid=b.id AND b.login='".sql_encodeValue($login)."' AND b.pass='".sql_encodeValue($pass)."')");
	if ($n=sql_result($ss1)) {
		return $n['id'];
	}
	return false;
}

function checkVisuSid($visuId,$sid,$getCmd=false) {
	//prüft, ob die SID $sid einen gültigen Visu-Account repräsentiert (quasi Loggedin-Check)
	//$getData: true=ggf. visuUserList als Array zurückgeben, false=ggf. nur "true" zurückgeben
	//return: true=SID ist ok (oder Datensatz wenn $getCmd=true), false=SID ist ungültig
	if (isEmpty($sid)) {return false;}
	$ss1=sql_call("SELECT * FROM edomiLive.visuUserList WHERE (visuid=".$visuId." AND (sid IS NOT NULL) AND sid<>'LOGOUT' AND sid='".$sid."')");
	if ($n=sql_result($ss1)) {
		sql_call("UPDATE edomiLive.visuUserList SET actiondate=".sql_getNow()." WHERE (id=".$n['id'].")");
		if ($getCmd) {return $n;} else {return true;}
	}
	return false;
}

function createVisuSid() {
	//Erzeugt eine zufällige SID, die noch nicht vorhanden ist
	//return: SID als String aus Ziffern und Buchstaben A..F (max. 30-stellig)
	do {
		$sid=substr(strtoupper(dechex(intval(rand(1000000,1000000000))).dechex(intval(strtotime('NOW')*rand(1,1000000))).dechex(intval(rand(1000000,1000000000)))),0,30);
		$ss1=sql_call("SELECT id FROM edomiLive.visuUserList WHERE (sid='".$sid."')");
	} while (sql_result($ss1));
	return $sid;
}

?>
